---
title: Firefox 65 for developers
slug: Mozilla/Firefox/Releases/65
tags:
  - '65'
  - Firefox
  - Mozilla
  - Release
---
<div>{{FirefoxSidebar}}</div>

<p>This article provides information about the changes in Firefox 65 that will affect developers. Firefox 65 was released on January 29, 2019.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<ul>
 <li>The <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_Flexbox_layouts">Flexbox inspector</a> is now enabled by default.</li>
 <li>Support has been added to the <a href="/en-US/docs/Tools/Debugger">JavaScript Debugger</a> for XHR Breakpoints ({{bug(821610)}}).</li>
 <li>Right-click on an item in the accessibility tree from the Accessibility viewer to <a href="/en-US/docs/Tools/Accessibility_inspector#Print_accessibility_tree_to_json">print it as json</a> to the JSON viewer.</li>
 <li>The <a href="/en-US/docs/Tools/Accessibility_inspector#Color_Contrast">color contrast</a> display of the Accessibility Picker has been updated so that if a text's background is complex (e.g. a gradient or complex image), it shows a range of color contrast values.</li>
 <li>The Headers tab of the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> now displays the Referrer Policy for the selected request ({{bug(1496742)}}).</li>
 <li>When displaying stack traces (e.g. in console logs or the JavaScript debugger), calls to framework methods are identified and collapsed by default, making it easier to home in on your code.</li>
 <li>In the same fashion as native terminals, you can now use reverse search to find entries in your JavaScript console history (<kbd>F9</kbd> on Windows/Linux or <kbd>Ctrl</kbd> + <kbd>R</kbd> on macOS, then type a search term, followed by <kbd>Ctrl</kbd> + <kbd>R</kbd>/<kbd>Ctrl</kbd> + <kbd>S</kbd> to toggle through results).</li>
 <li>The JavaScript console's <code>$0</code> shortcut (references the currently inspected element on the page) now has autocomplete available, so for example you could type <code>$0.te</code> to get autocomplete suggestions for properties like <code>$0.textContent</code>.</li>
 <li>The edits you make in the Rules view of the Inspector are now listed in the Changes panel ({{bug(1503920)}}).</li>
</ul>

<h3 id="HTML">HTML</h3>

<ul>
 <li>Events are now dispatched on disabled HTML elements, i.e. {{htmlelement("button")}}, {{htmlelement("fieldset")}}, {{htmlelement("input")}}, {{htmlelement("select")}}, and {{htmlelement("textarea")}} elements with <code>disabled</code> attributes set on them ({{bug(329509)}}).</li>
 <li>Removing the <code>src</code> attribute of an {{htmlelement("iframe")}} element now causes <code>about:blank</code> to be loaded into it, giving it parity with Chrome and Safari ({{bug(1507842)}}). Previously removing <code>src</code> had no effect on the <code>iframe</code> content.</li>
 <li>We have added support for the {{htmlattrxref("referrerpolicy", "script")}} attribute on {{htmlelement("script")}} elements ({{bug(1460920)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>The {{cssxref("image-rendering")}} property's <code>crisp-edges</code> value has now been unprefixed ({{bug(1496617)}}).</li>
 <li>A {{cssxref("scrollbar-color")}} value of <code>auto</code> now resolves to <code>auto</code>, rather than two colors ({{bug(1501418)}}).</li>
 <li>The <code>break-*</code> properties have been implemented, and the legacy <code>page-break-*</code> properties have been aliased to them ({{bug(775618)}}):
  <ul>
   <li>{{cssxref("break-before")}} is now an alias for {{cssxref("page-break-before")}}.</li>
   <li>{{cssxref("break-after")}} is now an alias for {{cssxref("page-break-after")}}.</li>
   <li>{{cssxref("break-inside")}} is now an alias for {{cssxref("page-break-inside")}}.</li>
  </ul>
 </li>
 <li>The {{cssxref("overflow-wrap")}} property's <code>anywhere</code> value has been implemented ({{bug(1505786)}}).</li>
 <li>The new step position keywords <code>jump-start</code>, <code>jump-end</code>, <code>jump-none</code>, and <code>jump-both</code> — usable inside the <a href="/en-US/docs/Web/CSS/single-transition-timing-function#The_steps()_class_of_timing_functions"><code>steps()</code> timing function</a> — have been implemented ({{bug(1496619)}}). This also coincides with the removal of the <code>frames()</code> timing function, which was the previous way of implementing such functionality, now deprecated.</li>
 <li>Some new {{cssxref("appearance", "-webkit-appearance")}} values have been added, for compatibility with other browsers. In particular:
  <ul>
   <li><code>meter</code>, which is now used as the default value for {{htmlelement("meter")}} elements in UA stylesheets. the existing value <code>meterbar</code> is now an alias for <code>meter</code> ({{bug(1501483)}}).</li>
   <li><code>progress-bar</code>, which is now used as the default value for {{htmlelement("progress")}} elements in UA stylesheets. the existing value <code>progressbar</code> is now an alias for <code>progress-bar</code> ({{bug(1501506)}}).</li>
   <li><code>textarea</code>, which is now used as the default value for {{htmlelement("textarea")}} elements in UA stylesheets. the existing value <code>textfield-multiline</code> is now an alias for <code>textarea</code> ({{bug(1507905)}})</li>
  </ul>
 </li>
 <li>The behavior of {{cssxref("user-select")}} has been changed to make it align more with other browsers ({{bug(1506547)}}). Specifically:
  <ul>
   <li><code>user-select: all</code> set on an element no longer overrides other values of <code>user-select</code> set on children of that element. So for example in the following snippet:
    <pre class="brush: html">&lt;div style="-webkit-user-select: all"&gt;All
  &lt;div style="-webkit-user-select: none"&gt;None&lt;/div&gt;
&lt;/div&gt;</pre>
    The <code>&lt;div&gt;</code> with <code>none</code> set on it is now non-selectable. Previously this value would have been overriden by the <code>all</code> value set on the parent element.</li>
   <li>non-<code>contenteditable</code> elements nested inside <code>contenteditable</code> elements  are now selectable.</li>
   <li><code>user-select</code> now behaves consistently inside and outside shadow DOM.</li>
   <li>The proprietary <code>-moz-text</code> value has been removed.</li>
  </ul>
 </li>
 <li>CSS environment variables (the {{cssxref("env")}} function) have been implemented ({{bug(1462233)}}).</li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>The <code>layout.css.shape-outside.enabled</code> pref has been removed; {{cssxref("shape-outside")}}, {{cssxref("shape-margin")}}, and {{cssxref("shape-image-threshold")}} can no longer be disabled in <code>about:config</code> ({{bug(1504387)}}).</li>
 <li>Several Firefox-only values of the {{cssxref("user-select")}} property have been removed — <code>-moz-all</code>, <code>-moz-text</code>, <code>tri-state</code>, <code>element</code>, <code>elements</code>, and <code>toggle</code>. See {{bug(1492958)}} and {{bug(1506547)}}.</li>
 <li>As mentioned above, the <code>frames()</code> timing function has been removed ({{bug(1496619)}}).</li>
</ul>

<h3 id="SVG">SVG</h3>

<p><em>No changes.</em></p>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>{{jsxref("RelativeTimeFormat", "Intl.RelativeTimeFormat")}} is now supported ({{bug(1504334)}}).</li>
 <li>Strings now have a maximum {{jsxref("String/length","length","","1")}} of <code>2**30 - 2</code> (~1GB) instead of <code>2**28 - 1</code> (~256MB) ({{bug(1509542)}}).</li>
 <li>The {{jsxref("globalThis")}} property, which always refers to the top-level global object, has been implemented ({{bug(1317422)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<ul>
 <li>{{domxref("Streams_API/Using_readable_streams", "Readable Streams", "", "1")}} have been enabled by default ({{bug(1505122)}}).</li>
 <li>The {{domxref("Storage_Access_API", "Storage Access API", "", "1")}} has been enabled by default ({{bug(1513021)}}).</li>
</ul>

<h4 id="DOM">DOM</h4>

<ul>
 <li>{{domxref("Performance.toJSON()")}} has been exposed to {{domxref("Web_Workers_API", "Web Workers", "", "1")}} ({{bug(1504958)}}).</li>
 <li>{{domxref("XMLHttpRequest")}} requests will now throw a <code>NetworkError</code> if the requested content type is a <code>Blob</code>, and the request method is not <code>GET</code> ({{bug(1502599)}}).</li>
 <li>The <code>-moz-</code> prefixed versions of many of the {{domxref("Fullscreen API", "", "", "1")}} features have been deprecated, and will now display deprecation warnings in the JavaScript console when encountered ({{bug(1504946)}}).</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.createImageBitmap", "createImageBitmap()")}} now supports SVG images ({{domxref("SVGImageElement")}}) as an image source ({{bug(1500768)}}).</li>
</ul>

<h4 id="DOM_events">DOM events</h4>

<ul>
 <li>Going forward, only one {{domxref("Window.open()")}} call is allowed per event ({{bug(675574)}}).</li>
 <li>The <code><a href="/en-US/docs/Web/Events/keyup">keyup</a></code> and <code><a href="/en-US/docs/Web/Events/keydown">keydown</a></code> events are now fired during IME composition, to improve cross-browser compatibility for CJKT users ({{bug(354358)}}, also see<br>
  <a href="https://www.fxsitecompat.com/en-CA/docs/2018/keydown-and-keyup-events-are-now-fired-during-ime-composition/">keydown and keyup events are now fired during IME composition</a> for more useful details).</li>
</ul>

<h4 id="Web_workers">Web workers</h4>

<ul>
 <li>{{domxref("SharedWorkerGlobalScope.onconnect")}}'s event object is a {{domxref("MessageEvent")}} instance — its <code>data</code> property is now an empty string value rather than <code>null</code> ({{bug(1508824)}}).</li>
</ul>

<h4 id="Fetch_and_Service_workers">Fetch and Service workers</h4>

<ul>
 <li>The {{domxref("Response.redirect()")}} method now correctly throws a <code>TypeError</code> if a non-valid URL is specified as the first parameter ({{bug(1503276)}}).</li>
 <li>The {{domxref("ServiceWorkerContainer.register()")}} and {{domxref("WorkerGlobalScope.importScripts()")}} (when used by a service worker) methods will now accept any files with a valid <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types#textjavascript">JavaScript MIME type</a> ({{bug(1354577)}}).</li>
 <li>The {{domxref("FetchEvent.replacesClientId")}} and {{domxref("FetchEvent.resultingClientId")}} properties are now supported ({{bug(1264177)}}).</li>
 <li>The {{domxref("ServiceWorkerGlobalScope.onmessageerror")}} and {{domxref("ServiceWorkerContainer.onmessageerror")}} handler properties have been implemented ({{bug(1399446)}}).</li>
 <li>The {{httpheader("Origin")}} header is no longer set on Fetch requests with a method of {{HTTPMethod("HEAD")}} or {{HTTPMethod("GET")}} ({{bug(1508661)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The {{domxref("WebRTC API", "WebRTC", "", "1")}} {{domxref("RTCIceCandidateStats")}} dictionary has been updated according to the latest spec changes ({{bug(1324788)}}, {{bug(1489040)}}; see also<br>
  <a href="https://www.fxsitecompat.com/en-CA/docs/2018/rtcicecandidatestats-has-been-updated-to-the-latest-spec/">RTCIceCandidateStats has been updated to the latest spec</a> for more details on exactly what has changed).</li>
 <li>The {{domxref("MediaRecorder")}} <code>pause</code> and <code>resume</code> events (and their corresponding event handler properties — {{domxref("MediaRecorder.onpause")}} and {{domxref("MediaRecorder.onresume")}}) were not previously implemented, even though compatibility tables claimed they had been. They have now been implemented ({{bug(1458538)}}, {{bug(1514016)}}).</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>The  {{domxref("WebGL API", "WebGL", "", "1")}} {{domxref("EXT_texture_compression_bptc")}} and {{domxref("EXT_texture_compression_rgtc")}} texture compression extensions have been exposed to WebGL1 and WebGL2 contexts ({{bug(1507263)}}).</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li><a href="/en-US/docs/Web/Guide/Events/Mutation_events">Mutation events</a> have been disabled in shadow trees ({{bug(1489858)}}).</li>
 <li>The non-standard {{domxref("MediaStream")}} property <code>currentTime</code> has been removed ({{bug(1502927)}}).</li>
 <li>The <code>dom.webcomponents.shadowdom.enabled</code> and <code>dom.webcomponents.customelements.enabled</code> prefs have been removed — Shadow DOM and Custom Elements can no longer be disabled in <code>about:config</code> ({{bug(1503019)}}).</li>
 <li>The non-standard DOM <code>text</code> event — fired to notify the browser editor UI of IME composition string data and selection range — has been removed ({{bug(1288640)}}).</li>
 <li>The {{event("keypress")}} event is no longer fired for <a href="/en-US/docs/Web/API/KeyboardEvent/keyCode#Non-printable_keys_(function_keys)">non-printable keys</a> ({{bug(968056)}}), except for the <kbd>Enter</kbd> key, and the <kbd>Shift</kbd> + <kbd>Enter</kbd> and <kbd>Ctrl</kbd> + <kbd>Enter</kbd> key combinations (these were kept for cross-browser compatibility purposes).</li>
</ul>

<h3 id="Security">Security</h3>

<ul>
 <li>Additional CORS restrictions are now being enforced on allowable request headers ({{bug(1483815)}}, see also <a href="https://github.com/whatwg/fetch/issues/382">whatwg fetch issue 382: CORS-safelisted request headers should be restricted according to RFC 7231</a> for more details).</li>
</ul>

<h3 id="Networking">Networking</h3>

<p><em>No changes.</em></p>

<h3 id="Plugins">Plugins</h3>

<p><em>No changes.</em></p>

<h3 id="WebDriver_conformance_Marionette">WebDriver conformance (Marionette)</h3>

<h4 id="API_changes">API changes</h4>

<ul>
 <li><code>WebDriver:ElementSendKeys</code> now handles <code>&lt;input type=file&gt;</code> more relaxed for interactability checks, and allows those elements to be hidden without raising a <code>not interactable</code> error anymore. If a strict interactability check is wanted the capability <code>strictFileInteractability</code> can be used ({{bug(1502864)}}).</li>
</ul>

<h4 id="Bug_fixes">Bug fixes</h4>

<ul>
 <li>The window manipulation commands <code>WebDriver:FullscreenWindow</code>, <code>WebDriver:MinimizeWindow</code>, <code>WebDriver:MaximizeWindow</code>, and <code>WebDriver:SetWindowRect</code> have been made more stable ({{bug(1492499)}}). It means that under special conditions they don't cause an infinite hang anymore, but instead timeout after 5s if the requested window state cannot be reached ({{bug(1521527)}}).</li>
 <li><code>WebDriver:ElementClick</code> now correctly calculates the center point of the element to click, which allows interactions with dimensions of 1x1 pixels ({{bug(1499360)}}).</li>
</ul>

<h4 id="Others">Others</h4>

<ul>
 <li>For <code>unexpected alert open</code> errors more informative messages are provided ({{bug(1502268)}}).</li>
</ul>

<h3 id="Other">Other</h3>

<ul>
 <li>Support for <a href="/en-US/docs/Glossary/webp">WebP</a> images has been added ({{bug(1294490)}}).

  <ul>
   <li>In addition, to faciliate cross-browser compatibility in certain situations the WebP MIMEType (<code>image/webp</code>) has been added to the standard HTTP Request {{httpheader("Accept")}} header for HTML files ({{bug(1507691)}}).</li>
  </ul>
 </li>
 <li>The AV1 codec is now supported by default on Windows ({{bug(1452146)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes_2">API changes</h3>

<h4 id="Tabs">Tabs</h4>

<ul>
 <li>The {{WebExtAPIRef("tabs", "tabs API", "", "1")}} has been enhanced to support tab successors — a tab can have a successor assigned to it, which is the ID of the tab that will be active once it is closed ({{bug(1500479)}}, also see <a href="https://qiita.com/piroor/items/ea7e727735631c45a366">this blog post</a> for more information). In particular:

  <ul>
   <li>The {{WebExtAPIRef("tabs.Tab")}} type now has a <code>successorId</code> property, which can be used to store/retrieve the ID of the tab's successor.</li>
   <li>The {{WebExtAPIRef("tabs.onActivated")}} event listener's callback has a new parameter available, <code>previousTabId</code>, which contains the ID of the previous activated tab, if it is still open.</li>
   <li>The {{WebExtAPIRef("tabs.update()")}} function's <code>updateProperties</code> object has a new optional property available on it, <code>successorTabId</code>, so can be used to update it.</li>
   <li><code>successorTabId</code> is also returned by functions like {{WebExtAPIRef("tabs.get()")}}  and {{WebExtAPIRef("tabs.query()")}}.</li>
   <li>The new function <code>tabs.moveInSuccession()</code> allows manipulation of tab successors in bulk.</li>
  </ul>
 </li>
</ul>

<h3 id="Manifest_changes">Manifest changes</h3>

<p><em>No changes.</em></p>

<h3 id="Other_2">Other</h3>

<ul>
 <li>The <code>headerURL</code>/<code>theme_frame</code> properties for <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/manifest.json/theme">Webextension themes</a> are now supported on Firefox for Android ({{bug(1429488)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks release post: <a href="https://hacks.mozilla.org/2019/01/firefox-65-webp-flexbox-inspector-new-tooling/">Firefox 65: WebP support, Flexbox Inspector, new tooling &amp; platform updates</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/65/">Site compatibility for Firefox 65</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(64)}}</p>
